#include "stdafx.h"

int leelin(FILE *fi, char *linea);
sql_context oracle_aplicacion(char *usu,char *cadena,int *resul);
HDC imprimir_listado(char *fichero,CWnd *parent,int *copias,int *pagina_inicial,int *pagina_final,int npaginas=0,char orientacion='\0');
void car(sql_context contexto,char *nombre,char *nombrefic,char *fichero,CListCtrl *lista,int *codigo,char *directorio_trabajo,char *usu,char *pass);

UINT thread_carga(LPVOID pParam)
{
	  parametros_carga *par = (parametros_carga *) pParam;

	  int resul;

	  sql_context contexto=oracle_aplicacion(par->usu,par->pass,&resul);
	  car(contexto,par->nombre,par->nombrefic,par->fichero,par->lista,&(par->codigo),par->directorio_trabajo,par->usu,par->pass);
	  out_or(contexto);
	  
	  return 0;
}

BEGIN_MESSAGE_MAP(carga1,CButton)
//{{AFX_MSG_MAP(carga1)
ON_WM_KEYDOWN()
ON_WM_SIZE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()
      
void carga1::create(CWnd *par, CRect *in_rect)
{
      CRect rect;
      register int t;
	  int n,i,j,lx,ly,l;
	  char fichero[25],linea[251],senten[1024],val_m[1500][61],tex_er[71],texto[61];
	  int tipo[5],n_max,n_reg,resul,n_vari;
	  FILE *fi;
	  LV_ITEM *item;
	  LV_COLUMN *columna;
	  	  
      parent=par;
      carga *ca=(carga *) parent;

	  resultado = new CBitmap;
	  mascara = new CBitmap;
	  imagen = new CImageList;
	  lista = new CListCtrl;

	  rect=*in_rect;
	  
      Create("",WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_GROUP |  BS_GROUPBOX,rect,par,NULL);

	  resultado->LoadBitmap("IDB_RESULTADO");
	  mascara->LoadBitmap("IDB_MASCARA");

	  imagen->Create(16,16,ILC_MASK,2,2);
	  imagen->Add(resultado,mascara);
	  	  
	  j=1;
	  n=50*4;
	  i=baseY/2;
	  lx=((n*baseX)/4)+2;
	  ly=(140*baseY)/8;

	  lista->Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_BORDER | LVS_NOSORTHEADER | LVS_REPORT | LVS_SINGLESEL | LVS_SHAREIMAGELISTS | LVS_SHOWSELALWAYS,CRect(j,i,lx,ly),this,NULL);
	  lista->SetImageList(imagen,LVSIL_SMALL);

	  columna=(LV_COLUMN *) malloc(sizeof(LV_COLUMN));
      columna->mask=LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
      columna->fmt=LVCFMT_LEFT;

	  for (t=0;t<2;t++) {
		 if (!t) {
            if (lenguaje=='E')
	           columna->pszText="Fichero";
            else
               columna->pszText="File";
	        columna->cx=((20*4)*baseX)/4;
		 }
		 if (t==1) {
            if (lenguaje=='E')
               columna->pszText="Proceso de carga";
            else
               columna->pszText="Loading process";
	        columna->cx=((30*4)*baseX)/4;
		 }
		 columna->iSubItem=t;
		 lista->InsertColumn(t,columna);
	  }
	  
	  free(columna);
	  
		              /* obtiene la lista a insertar */

      strcpy(fichero,ca->nombre);
      strcat(fichero,".car");

      if ((fi=fopen(fichero,"r"))!=NULL) {
         do {
            l=leelin(fi,linea);
	        if (l==EOF) break;
	        rtrim(linea);
			break;
		 } while(1);
		 fclose(fi);
	  }

	  strcpy(senten,"select fichero from ");
	  strcat(senten,linea);
	  strcat(senten," order by fichero");
	  
	  n_vari=1;
	  tipo[0]=1;
	  n_max=300;
	  
	  resul=sq3_or(ca->contex_gen,senten,tipo,n_vari,n_max,&n_reg,val_m,tex_er);

	  if (n_reg) lista->SetItemCount(n_reg);

	  item=(LV_ITEM *) malloc(sizeof(LV_ITEM));

	  item->mask=LVIF_TEXT | LVIF_PARAM;

	  unsigned char a='\0';
      
	  item->lParam=MAKELPARAM(MAKEWORD(a,a),MAKEWORD(a,a));
	  	  	  
	  texto[0]='\0';

      for (t=0;t<n_reg;t++) {
	     item->iItem=t;
		 item->iSubItem=0;
         item->pszText=val_m[t];
		 lista->InsertItem(item);
		 lista->SetItemText(t,1,texto);
	  }

	  lista->SetItemState(0,LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);

	  for (t=1;t<n_reg;t++) lista->SetItemState(t,NULL,LVIS_FOCUSED | LVIS_SELECTED); 
      
      free(item);

      for (t=0;t<n_reg;t++) asignar_imagen(t,2);

	  lista->SetFont(fonm,TRUE);
	  lista->SetFocus();
}	  

void carga1::asignar_imagen(int numero,int numero_imagen)
{
      LV_ITEM *item;
	  	  	  
	  item=(LV_ITEM *) malloc(sizeof(LV_ITEM));
	  item->mask=LVIF_IMAGE;
	  item->iItem=numero;        
      item->iSubItem=0;

	  item->iImage=numero_imagen;
	  	  
	  lista->SetItem(item);
	  free(item);
}

void carga1::obtener_fichero(int numero, char *fichero)	  
{
	  lista->GetItemText(numero,0,fichero,31);
}

void carga1::OnSize(UINT nType,int cx,int cy)
{
	  CButton::OnSize(nType,cx,cy);
	  if (lista->m_hWnd)
         lista->MoveWindow(1,baseY/2,cx-2,cy-(baseY/2),TRUE);
}

int carga1::obtener_seleccionado()
{
      register int t;

      for (t=0;t<lista->GetItemCount();t++) {
         if (lista->GetItemState(t,LVIS_SELECTED) == LVIS_SELECTED ||
		    lista->GetItemState(t,LVIS_FOCUSED) == LVIS_FOCUSED) return(t);
	  } 
	  return(-1);
}

char carga1::get_marca_edit(int numero)
{
	  return((char) LOBYTE(LOWORD(lista->GetItemData(numero))));
}

char carga1::get_marca_impre(int numero)
{
      return((char) HIBYTE(LOWORD(lista->GetItemData(numero))));
}

char carga1::get_marca_carga(int numero) 
{
	  return((char) LOBYTE(HIWORD(lista->GetItemData(numero))));
}

char carga1::get_marca_error(int numero)
{
	  return((char) HIBYTE(HIWORD(lista->GetItemData(numero))));
}

void carga1::put_marca_edit(char *informe,char marca)
{
	  unsigned char d,i,c,e;

	  LV_FINDINFO info;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);

	  d=LOBYTE(LOWORD(lista->GetItemData(numero)));
      i=HIBYTE(LOWORD(lista->GetItemData(numero)));
	  c=LOBYTE(HIWORD(lista->GetItemData(numero)));
	  e=HIBYTE(HIWORD(lista->GetItemData(numero)));

	  lista->SetItemData(numero,MAKELPARAM(MAKEWORD((unsigned char) marca,i),MAKEWORD(c,e)));
}

void carga1::put_marca_impre(char *informe,char marca)
{
	  unsigned char d,i,c,e;

      LV_FINDINFO info;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);

	  d=LOBYTE(LOWORD(lista->GetItemData(numero)));
      i=HIBYTE(LOWORD(lista->GetItemData(numero)));
	  c=LOBYTE(HIWORD(lista->GetItemData(numero)));
	  e=HIBYTE(HIWORD(lista->GetItemData(numero)));

	  lista->SetItemData(numero,MAKELPARAM(MAKEWORD(d,(unsigned char) marca),MAKEWORD(c,e))); 
}

void carga1::put_marca_carga(char *informe,char marca)
{
	  unsigned char d,i,c,e;

	  LV_FINDINFO info;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);

	  d=LOBYTE(LOWORD(lista->GetItemData(numero)));
      i=HIBYTE(LOWORD(lista->GetItemData(numero)));
	  c=LOBYTE(HIWORD(lista->GetItemData(numero)));
	  e=HIBYTE(HIWORD(lista->GetItemData(numero)));

	  lista->SetItemData(numero,MAKELPARAM(MAKEWORD(d,i),MAKEWORD((unsigned char) marca,e)));
}

void carga1::put_marca_error(char *informe,char marca)
{
	  unsigned char d,i,c,e;

	  LV_FINDINFO info;

	  info.flags=LVFI_STRING;
	  info.psz=informe;
	  
	  int numero=lista->FindItem(&info);

	  d=LOBYTE(LOWORD(lista->GetItemData(numero)));
      i=HIBYTE(LOWORD(lista->GetItemData(numero)));
	  c=LOBYTE(HIWORD(lista->GetItemData(numero)));
	  e=HIBYTE(HIWORD(lista->GetItemData(numero)));

	  lista->SetItemData(numero,MAKELPARAM(MAKEWORD(d,i),MAKEWORD(c,(unsigned char) marca)));
}

BOOL carga1::PreTranslateMessage(MSG *pMsg)
{
	  if (pMsg->message == WM_KEYDOWN) {
		 if (pMsg->wParam == VK_DELETE) { 
            int numero=obtener_seleccionado();
            carga *ca=(carga *) parent;
            ca->borrar(numero);
            return TRUE;
		 } 
      }

      return CButton::PreTranslateMessage(pMsg);	  
}

BEGIN_MESSAGE_MAP(carga,CDialog)
//{{AFX_MSG_MAP(carga)
ON_WM_SIZE()
ON_WM_KEYDOWN()
ON_WM_CLOSE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void carga::create(CWnd *parent, char *opcion, char autorizacion, char *no, char *directory, char *us, char *pa, sql_context contexto, int b)
{
	  FILE *fi;
	  register int t;
      CRect rect;
	  int j,i,l,n,px,py,lx,ly,f,g;
	  char texto[251],linea[251],fichero[101];
	  HICON icon[4];

	  contex_gen=contexto;

	  strcpy(nom,no);
	  strcpy(directorio_trabajo,directory);
	  strcpy(usu,us);
	  strcpy(pass,pa);

	  size_bitmap=b;	  

	  if (!autorizacion) {
         if (er) delete er;
		 er = new error_aplicacion;
         if (lenguaje=='E')
            strcpy(texto,"Usuario no autorizado");
         else
            strcpy(texto,"User not authorised");
		 er->create(texto);
	  } else {
         acceso=autorizacion;
	     strcpy(nombre,opcion);

	     icon[0]=AfxGetApp()->LoadIcon("IDC_NUEVA_CARGA");
	     icon[1]=AfxGetApp()->LoadIcon("IDC_CARGA");
	     icon[2]=AfxGetApp()->LoadIcon("IDC_FIC_BASE");
	     icon[3]=AfxGetApp()->LoadIcon("IDC_IMPRE");
	     
		 ed = new edit[5];
	     for (t=0;t<5;t++) indicador_ed[t]=0;
		 for (t=0;t<5;t++) {
			estado_carga[t]=0;
			par[t] = new parametros_carga;
		 }
		 err = new errores[5];
		 for (t=0;t<5;t++) indicador_er[t]=0;
		 	 		 
	     f=(50*4)+2;
	     g=(140*baseY)/8;

         lx=((f*baseX)/4)+2;
	     ly=25+g+baseM+((10*baseY)/8);
         if (ly>(baseTY-10)) ly=baseTY-10;
         if (lx>(baseTX-10)) lx=baseTX-10;
	     rect.SetRect(0,0,lx,ly);

         AdjustWindowRectEx(rect,WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME,FALSE,0);

	     strcpy(fichero,nombre);
         strcat(fichero,".car");

         if ((fi=fopen(fichero,"r"))!=NULL) {
            do {
               l=leelin(fi,linea);
	           if (l==EOF) break;
			   l=leelin(fi,linea);
	           if (l==EOF) break;
               l=leelin(fi,linea);
               if (lenguaje!='E') l=leelin(fi,linea);
	           if (l==EOF) break;
	           rtrim(linea);
			   break;
			} while(1);
		    fclose(fi);
		 }

	     px=strlen(opcion)*2;
	     py=5*baseM;
	     px=(px*baseX)/4;
         if ((px+lx)>baseTX) px=baseTX-lx;
         if ((py+ly)>baseTY) py=baseTY-ly;
	     
		 strcpy(texto,nom);
		 if (*nom) strcat(texto," - ");
		 strcat(texto,linea);

	     CreateEx(0,xd_wnd_class,texto,WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME,px,py,rect.Width(),rect.Height(),parent->m_hWnd,NULL);

		 CWaitCursor cursor;

         lx=(f*baseX)/4;
	     rect.SetRect(1,25,lx+1,g+25);

	     ca1.create(this,&rect);

	     py=4;
	     ly=24;
         px=((f*baseX)/4)+2-(size_bitmap+5);
	     lx=px+size_bitmap;
	     titulo->Create("titulo",WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_OWNERDRAW,CRect(px,py,lx,ly),this,NULL);
         titulo->LoadBitmaps("IDB_APLICACION",NULL,NULL,NULL);

         n=6;

	     for (t=0;t<4;t++) {
            if (t) n+=23;
	        if (t==1) n+=10;
	        tool[t]->Create(NULL,WS_CHILD | WS_VISIBLE | WS_TABSTOP,CRect(n,4,n+23,26),this,NULL);
	        tool[t]->ModifyStyle(0,BS_ICON | BS_CENTER);
            if (t==2 && acceso=='R') tool[t]->ModifyStyle(0,WS_DISABLED);
	        tool[t]->SetIcon(icon[t]);
		 }
		 
		 j=5;
	  
         for (t=0;t<3;t++) {
            if (lenguaje=='E') {
               if (!t) strcpy(texto,"Salir");
               if (t==1) strcpy(texto,"Ayuda");   
			   if (t==2) strcpy(texto,"Cancelar");
            } else {
               if (!t) strcpy(texto,"Exit");
               if (t==1) strcpy(texto,"Help");   
			   if (t==2) strcpy(texto,"Cancel");
            }
            i=25+g+((5*baseY)/8);     
		    l=i+baseM;
			if (t<2) 
		       n=j+(4*5)+4;
			else
               n=j+(4*8)+4;
		    px=(j*baseX)/4;
	        lx=(n*baseX)/4;
            boton[t]->Create(texto,WS_CHILD | WS_VISIBLE | WS_TABSTOP,CRect(px,i,lx,l),this,NULL);
            boton[t]->SetFont(fonm,TRUE);
			if (t==2) boton[t]->EnableWindow(FALSE);
			j+=5+(4*5)+4;
		 }

	     tip->Create(this,TTS_ALWAYSTIP);
	  	 
	     for (t=0;t<5;t++) textip[t]=(char *) malloc(41);

         if (lenguaje=='E') {
		    strcpy(textip[0],"Nuevo fichero de carga");
		    strcpy(textip[1],"Editar fichero de carga");
            strcpy(textip[2],"Cargar fichero en base de datos");
		    strcpy(textip[3],"Imprimir fichero de carga");
         } else {
            strcpy(textip[0],"New load file");
		    strcpy(textip[1],"Edit load file");
            strcpy(textip[2],"Load file in the database");
		    strcpy(textip[3],"Print load file");
		 }
			
         strcpy(textip[4],identificacion_aplicacion);

		 for (t=0;t<4;t++) tip->AddTool(tool[t],textip[t]);
		     
	     tip->AddTool(titulo,textip[t]);

	     tip->Activate(TRUE);

         this->ShowWindow(SW_SHOW);
	     indicador=1;
	  }
}

void carga::set_tool(int numero)
{
      tool[numero]->EnableWindow(TRUE);
}

void carga::unset_tool(int numero)
{
      tool[numero]->EnableWindow(FALSE);
}

void carga::OnSize(UINT nType,int cx,int cy)
{
	  int px,py,lx,ly;
	  register int t;
	  
      CDialog::OnSize(nType,cx,cy);

	  if (titulo->m_hWnd) {
         py=4;
	     px=cx-(size_bitmap+5);
         titulo->InvalidateRgn(NULL);
	     titulo->MoveWindow(px,py,size_bitmap,20,TRUE);
	  }
	     
	  if (boton[0]->m_hWnd) {
		 px=(5*baseX)/4;
		 py=((5*baseY)/8)+baseM;
		 lx=(((4*5)+4)*baseX)/4;
         boton[0]->InvalidateRgn(NULL);
	     boton[0]->MoveWindow(px,cy-py,lx,baseM,TRUE);
      }

	  if (boton[1]->m_hWnd) {
		 px=((10+(4*5)+4)*baseX)/4;
		 py=((5*baseY)/8)+baseM;
		 lx=(((4*5)+4)*baseX)/4;
         boton[1]->InvalidateRgn(NULL);
	     boton[1]->MoveWindow(px,cy-py,lx,baseM,TRUE);
      }

      if (boton[2]->m_hWnd) {
		 px=((15+(4*10)+8)*baseX)/4;
		 py=((5*baseY)/8)+baseM;
		 lx=(((4*8)+4)*baseX)/4;
         boton[2]->InvalidateRgn(NULL);
	     boton[2]->MoveWindow(px,cy-py,lx,baseM,TRUE);
      }

      if (ca1.m_hWnd) {
		 py=25;
		 ly=25+((10*baseY)/8)+baseM;
         ca1.InvalidateRgn(NULL);
	     ca1.MoveWindow(1,py,cx-4,cy-ly,TRUE);
	  }

	  px=6;
	  for (t=0;t<4;t++) {
         if (t) px+=23;
		 if (t==1) px+=10;
		 if (tool[t]->m_hWnd) {
            tool[t]->InvalidateRgn(NULL);
			tool[t]->MoveWindow(px,4,24,22,TRUE);
		 }
	  }
}

BOOL carga::PreTranslateMessage(MSG *pMsg)
{
	  register int t;

	  for (t=0;t<5;t++) {
	     if (estado_carga[t]) {
	        char file[512];
		    strcpy(file,directorio_aplicacion);
            strcat(file,"\\");
		    strcat(file,par[t]->nombrefic);
		    strcat(file,".carga");

		    CCriticalSection bloque;
		    bloque.Lock();

            int h=_open(file,_O_RDONLY);
		    if (h==-1) {
		       final_ejecucion(t);
			   return TRUE;
			} else
               _close(h);

		    bloque.Unlock();
		 }
	  }
	  
	  switch(pMsg->message) {
	     case WM_LBUTTONDOWN:
         case WM_RBUTTONDOWN:
         case WM_MBUTTONDOWN:
         case WM_LBUTTONUP:
         case WM_RBUTTONUP:
         case WM_MBUTTONUP:
         case WM_MOUSEMOVE:
            tip->Activate(TRUE);
            tip->RelayEvent(pMsg);
      } 

	  if (pMsg->message == WM_LBUTTONDBLCLK) {
         UINT nFlags;
		 this->ScreenToClient(&(pMsg->pt));
		 pMsg->pt.x-=2;
		 pMsg->pt.y-=(25+(baseY/2));
		 int numero = ca1.lista->HitTest(pMsg->pt,&nFlags);
         if (numero != -1 && nFlags & LVHT_ONITEM) {
            visualizar_errores(numero);
            return TRUE;
		 }
      }

      if (pMsg->message == WM_KEYDOWN) {
		 if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE || pMsg->wParam == VK_F1) { 
			this->SendMessage(WM_KEYDOWN,pMsg->wParam);
			return TRUE;
         } 
      }

      return CDialog::PreTranslateMessage(pMsg);	  
}

void carga::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
      CDialog::OnKeyDown(nChar,nRepCnt,nFlags);
      
      if (nChar == VK_F1) desplegar_ayuda();
}

void carga::OnClose()
{
      salir();
}

int carga::salir()
{
	  DWORD codigo;
	  register int t;
      char texto[61];

	  for (t=0;t<5;t++) {
	     if (::GetExitCodeThread(hThread[t],&codigo)) {
			if (codigo==STILL_ACTIVE) {
			   if (er) delete er;
		       er = new error_aplicacion;
               if (lenguaje=='E') 
		          strcpy(texto,"Proceso de carga masiva activo.");
               else
                  strcpy(texto,"Loading batch load file.");
               er->create(texto);
			   return(1);
			}
		 }
	  }

	  for (t=0;t<5;t++) {
		 if (indicador_ed[t]) {
			if (ed[t].ed1.grid->modi) {
               if (er) delete er;
		       er = new error_aplicacion;
               if (lenguaje=='E')
                  strcpy(texto,"Fichero de carga masiva en edicin\ny con modificaciones.");
               else
                  strcpy(texto,"Editing and modifying batch load file.");
		       er->create(texto);
			   return(1);
			}
		 }
	  }
            
	  for (t=0;t<5;t++) delete par[t];
	  for (t=0;t<5;t++) free(textip[t]);
	  this->ShowWindow(SW_HIDE);
	  this->DestroyWindow();
	  delete ca1.mascara;
	  delete ca1.resultado;
	  delete ca1.imagen;
	  delete ca1.lista;
	  delete [] ed;
	  delete [] err;
	  indicador=0;
	  return(0);
}

void carga::editar(int numero)
{
      char fichero[31],fich[101],linea[51];
	  register int t,u,r;
	  char senten[1024],valor[1][61],val_m[600][61],tex_er[71],texto[61];
	  char nombre_campo[150][16],clave_campo[150][16],key_campo[150];
	  int l,tipo[6],resul,n_vari,n_max,n_reg,tipo_campo[150],lon_campo[150];
	  FILE *fi;
	  	  
	  char d=ca1.get_marca_edit(numero);
	  char c=ca1.get_marca_carga(numero);
	  char i=ca1.get_marca_impre(numero);

	  if (!d || !c || !i) {
         ca1.obtener_fichero(numero,fichero);	  
         for (t=0;t<5;t++) {
            if (!indicador_ed[t]) break;
		 }
		 if (t==5) {
            if (er) delete er;
			er = new error_aplicacion;
            if (lenguaje=='E')
               strcpy(texto,"Excedido el numero mximo (5) de\nficheros editados.");
            else
               strcpy(texto,"Maximum number (5) of edited files reached.");
			er->create(texto);
		 } else {

			char tab_fic[16],tab_tip[16];

	        strcpy(fich,nombre);
            strcat(fich,".car");

            if ((fi=fopen(fich,"r"))!=NULL) {
               do {
                  l=leelin(fi,linea);
	              if (l==EOF) break;
	              rtrim(linea);
			      strcpy(tab_fic,linea);
                  l=leelin(fi,linea);
	              if (l==EOF) break;
	              rtrim(linea);
			      strcpy(tab_tip,linea);
			      break;
			   } while(1);
		       fclose(fi);
			}
				            /* obtiene la tabla */

            strcpy(senten,"select tabla from ");
			strcat(senten,tab_fic);
			strcat(senten," where fichero='");
            strcat(senten,fichero);
	        strcat(senten,"'");
            n_vari=1;
	        tipo[0]=1;
            resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er); 

			strcpy(senten,"select nombre_campo,clave_campo,tipo_campo,lon_campo,key_campo from ");
			strcat(senten,tab_tip);
            strcat(senten," where fichero='");
            strcat(senten,fichero);
	        strcat(senten,"' order by num_campo");

	        n_vari=5;
	        tipo[0]=1;
			tipo[2]=1;
			tipo[3]=4;
			tipo[4]=4;
			tipo[5]=1;
            n_max=150;
	  
	        resul=sq3_or(contex_gen,senten,tipo,n_vari,n_max,&n_reg,val_m,tex_er);

			for (u=0,r=0;u<n_reg*5;u+=5,r++) {
               strcpy(nombre_campo[r],val_m[u]);
		       strcpy(clave_campo[r],val_m[u+1]);
               ltrim(val_m[u+2]);
		       tipo_campo[r]=atoi(val_m[u+2]);
			   ltrim(val_m[u+3]);
		       lon_campo[r]=atoi(val_m[u+3]);
		       key_campo[r]=val_m[u+4][0];
			}
	  
	        ed[t].create(this,t,n_reg,nombre_campo,clave_campo,key_campo,
				         lon_campo,tipo_campo,valor[0],fichero);
		 }
	  }
}

void carga::visualizar_errores(int numero)
{
	  char fichero[31],file[512],texto[101];
	  int i;
	  register int t;
	  	  
      char c=ca1.get_marca_carga(numero);
	  char e=ca1.get_marca_error(numero);

	  if (!c && !e) {
	     ca1.obtener_fichero(numero,fichero);	  

		 strcpy(file,directorio_trabajo);
         strcat(file,"\\");
	     strcat(file,fichero);
		 strcat(file,".err");

		 if ((i=_open(file,_O_RDONLY))!=-1) {
            _close(i);
            for (t=0;t<5;t++) {
               if (!indicador_er[t]) break;
			}
		    if (t==5) {
               if (er) delete er;
			   er = new error_aplicacion;
               if (lenguaje=='E')
                  strcpy(texto,"Excedido el numero mximo (5) de\nficheros de errores visualizados.");
               else
                  strcpy(texto,"Maximum number (5) of viewed error files reached.");
			   er->create(texto);
			} else {
	           err[t].create(this,fichero,t);
			}
		 }
	  }
}

void carga::nuevo()
{
	  tabcar.create(this);
}

void carga::imprimir(int numero)
{
	  char file[512],fichero[31],directorio[201];
	  int i,ini,fin,cop;

      ini=0;
      fin=0;
      cop=0;
	  	  
      char m=ca1.get_marca_impre(numero);
	  char c=ca1.get_marca_carga(numero);

	  if (!m && !c) {
	     ca1.obtener_fichero(numero,fichero);	  

	     strcpy(file,directorio_trabajo);
         strcat(file,"\\");
	     strcat(file,fichero);
         strcat(file,".txt");
	   
         if ((i=_open(file,_O_RDONLY))!=-1) {
            _close(i);
	        ca1.put_marca_impre(fichero,'i');
			GetCurrentDirectory(201,directorio);
			imprimir_listado(file,this,&cop,&ini,&fin);
			SetCurrentDirectory(directorio);
			ca1.put_marca_impre(fichero,'\0');
		 }
	  }
}

void carga::borrar(int numero)
{
	  char fichero[31],file[512];
	  int j,n_vari,tipo[1],l,resul;
	  char texto[201],linea[101],senten[2048],valor[1][61],tex_er[71];
	  FILE *fi;

	  ca1.obtener_fichero(numero,fichero);	  

	  char i=ca1.get_marca_impre(numero);
	  char d=ca1.get_marca_edit(numero);
	  char e=ca1.get_marca_error(numero);
	  char c=ca1.get_marca_carga(numero);

	  if (i || d || e || c) {
         if (er) delete er;
		 er = new error_aplicacion;
         if (lenguaje=='E')
		    strcpy(texto,"Fichero ");
         else
            strcpy(texto,"File ");
		 strcat(texto,fichero);
         if (lenguaje=='E')
		    strcat(texto," en uso.\n\nNo se puede borrar.");
         else
            strcat(texto," in use.\n\nCant delete it.");
		 er->create(texto);                           
	  } else {
         if (lenguaje=='E')
            strcpy(texto,"Desea borrar el fichero ");
         else
            strcpy(texto,"Delete file ");
	     strcat(texto,fichero);
         strcat(texto,"?");

         if (lenguaje=='E')
            j=MessageBoxEx(this->m_hWnd,texto,"borrar",MB_YESNO | MB_TASKMODAL | MB_DEFBUTTON2 |
		                   MB_ICONQUESTION,MAKELANGID(LANG_SPANISH,SUBLANG_SPANISH));
         else
            j=MessageBoxEx(this->m_hWnd,texto,"delete",MB_YESNO | MB_TASKMODAL | MB_DEFBUTTON2 |
		                   MB_ICONQUESTION,MAKELANGID(LANG_ENGLISH,SUBLANG_ENGLISH_US));

	     if (j==IDYES) {
            
            char tab_fic[16],tab_tip[16];

	        strcpy(file,nombre);
            strcat(file,".car");

            if ((fi=fopen(file,"r"))!=NULL) {
               do {
                  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_fic,linea);
                  l=leelin(fi,linea);
				  rtrim(linea);
	              strcpy(tab_tip,linea);
                  break;
			   } while(1);
		       fclose(fi);
			}

			strcpy(senten,"delete ");
	        strcat(senten,tab_fic);
	        strcat(senten," where fichero='");
	        strcat(senten,fichero);
	        strcat(senten,"'");
	        resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

			strcpy(senten,"delete "); 
			strcat(senten,tab_tip);
	        strcat(senten," where fichero='");
	        strcat(senten,fichero);
	        strcat(senten,"'");
	        resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);

            if (resul) {
               if (lenguaje=='E')
	              strcpy(texto,"No se puede borrar el fichero.\n\nError de ORACLE:\n\n ");
               else
                  strcpy(texto,"Can't delete file.\n\nORACLE error:\n\n ");
               strcat(texto,tex_er);
               if (er) delete er;
               er = new error_aplicacion;
               er->create(texto);
			} else {
               co_or(contex_gen);
               ca1.lista->DeleteItem(numero);

			   strcpy(file,directorio_trabajo);
               strcat(file,"\\");
	           strcat(file,fichero);
               strcat(file,".txt");
			   _unlink(file);
               l=strlen(file);
               file[l-4]='\0';
			   strcat(file,".err");
			   _unlink(file);
			} 
         }
	  }
}

void carga::inicio_ejecucion(int numero)
{
	  char fichero[31],file[512],fich[512],texto[101];
	  char senten[1024],valor[1][61],tex_er[71];
	  register int t;
	  FILE *fi;
      int j,n_vari,tipo[1],resul;
	  
	  char d=ca1.get_marca_edit(numero);
	  char c=ca1.get_marca_carga(numero);

	  if (!d && !c) {
         ca1.obtener_fichero(numero,fichero);	  
		 for (t=0;t<5;t++) {
            if (!estado_carga[t]) break;
		 }
		 if (t==5) {
            if (er) delete er;
		    er = new error_aplicacion;
            if (lenguaje=='E')
               strcpy(texto,"Excedido el numero mximo (5) de\nficheros en proceso de carga.");
            else
		       strcpy(texto,"Maximum number (5) of loading files in process reached.");
            er->create(texto);
		 } else {
            if (lenguaje=='E')
               strcpy(texto,"Desea cargar el fichero ");
            else
               strcpy(texto,"Load file ");
	        strcat(texto,fichero);
            strcat(texto,"?");
            if (lenguaje=='E')
               j=MessageBoxEx(this->m_hWnd,texto,"cargar fichero",MB_YESNO | MB_TASKMODAL | MB_DEFBUTTON1 |
		                   MB_ICONQUESTION,MAKELANGID(LANG_SPANISH,SUBLANG_SPANISH));
            else
               j=MessageBoxEx(this->m_hWnd,texto,"load file",MB_YESNO | MB_TASKMODAL | MB_DEFBUTTON1 |
		                   MB_ICONQUESTION,MAKELANGID(LANG_ENGLISH,SUBLANG_ENGLISH_US));

	        if (j==IDNO) return;
                         
			 /* obtiene con la hora un nombre de fichero */

            strcpy(senten,"select to_char(sysdate,'hh24miss') from dual");
	        n_vari=1;
	        tipo[0]=1;
	        resul=sq1_or(contex_gen,senten,valor,tipo,n_vari,tex_er);
            strcpy(par[t]->nombrefic,valor[0]);

            strcpy(par[t]->nombre,nombre);
			strcpy(par[t]->directorio_trabajo,directorio_trabajo);
			strcpy(par[t]->usu,usu);
			strcpy(par[t]->pass,pass);
			strcpy(par[t]->fichero,fichero);
			par[t]->lista=ca1.lista;
            par[t]->codigo=0;
			boton[2]->EnableWindow(TRUE);
			ca1.asignar_imagen(numero,2);
			ca1.put_marca_carga(fichero,'c');
			strcpy(fich,directorio_trabajo);
            strcat(fich,"\\");
			strcat(fich,fichero);
			strcat(fich,".err");
			_unlink(fich);
			strcpy(file,directorio_aplicacion);
            strcat(file,"\\");
			strcat(file,par[t]->nombrefic);
            strcat(file,".carga");
			if ((fi=fopen(file,"w"))!=NULL) {
               fprintf(fi,"%s","1");
			   fclose(fi);
			}
			estado_carga[t]++;

			CWinThread *tr=AfxBeginThread(thread_carga,par[t]);
			hThread[t]=tr->m_hThread;
		 }
	  }
}

void carga::final_ejecucion(int numero_ejecucion)
{
	  register int t;
	  
	  LV_FINDINFO info;
	 
	  info.flags=LVFI_STRING;
	  info.psz=par[numero_ejecucion]->fichero;
	  
	  int numero=ca1.lista->FindItem(&info);	  

	  if (!par[numero_ejecucion]->codigo)
         ca1.asignar_imagen(numero,0);
	  else
         ca1.asignar_imagen(numero,1);
         
	  ca1.put_marca_carga(par[numero_ejecucion]->fichero,'\0');

      estado_carga[numero_ejecucion]=0;

	  for (t=0;t<5;t++) {
		 if (estado_carga[t]) break;
      }

	  if (t==5) boton[2]->EnableWindow(FALSE);
}

BOOL carga::OnCommand(WPARAM wParam, LPARAM lParam)
{
	  UINT notificationCode = (UINT) HIWORD(wParam);
	  
	  if (notificationCode == BN_CLICKED) {
         int i;
         i=ca1.obtener_seleccionado();
	     CWnd *button = CWnd::GetFocus();
         if (button == tool[0]) nuevo();
         if (button == tool[1] && i>=0) editar(i);
         if (button == tool[2] && i>=0) inicio_ejecucion(i);
         if (button == tool[3] && i>=0) imprimir(i);
         if (button == boton[0]) salir();
         if (button == boton[1]) desplegar_ayuda();
	 	 if (button == boton[2]) cancelar();
		 return FALSE;
	  }
    
	  return CDialog::OnCommand(wParam, lParam);
}

int carga::obtener_indicador()
{
	  return indicador;
}

void carga::cancelar()
{
	  char file[512],mensaje[401];
	  int i,n;
	  register int t;
	  LV_FINDINFO info;
	 	  
	  int numero_seleccionado=ca1.obtener_seleccionado();

	  n=0;
	  for (t=0;t<5;t++) {
         if (estado_carga[t]) n++;
	  }

	  if (n==1) {
         for (t=0;t<5;t++) {
		    if (estado_carga[t]) { 
			   strcpy(file,directorio_aplicacion);
               strcat(file,"\\");
	           strcat(file,par[t]->nombrefic);
	           strcat(file,".carga");
               par[t]->codigo=1;

	           CCriticalSection bloque;
      	       bloque.Lock();

               do { 
                  i=_open(file,_O_RDONLY);
	              if (i==-1) break;
		          _close(i);
	              i=_unlink(file);
		          if (!i) break;
			   } while(1);

	           bloque.Unlock();
			   break;
			}
		 }
	  } else {
	     for (t=0;t<5;t++) {
		    if (estado_carga[t]) { 
			   info.flags=LVFI_STRING;
	           info.psz=par[t]->fichero;
	           int numero=ca1.lista->FindItem(&info);	  
			   if (numero==numero_seleccionado) {
                  strcpy(file,directorio_aplicacion);
                  strcat(file,"\\");
	              strcat(file,par[t]->nombrefic);
	              strcat(file,".carga");
                  par[t]->codigo=1;

	              CCriticalSection bloque;
      	          bloque.Lock();

                  do { 
                     i=_open(file,_O_RDONLY);
	                 if (i==-1) break;
		             _close(i);
	                 i=_unlink(file);
		             if (!i) break;
				  } while(1);

	              bloque.Unlock();
			      break;
			   }
			}
		 }
	  }

	  if (t==5) {
         if (er) delete er;
		 er = new error_aplicacion;
         if (lenguaje=='E')
		    strcpy(mensaje,"Hay mas de un fichero de carga msiva en\nproceso de ejecucin.\n\nSitue el cursor sobre el fichero que desee\n\ny pulse Cancelar de nuevo.");
         else
            strcpy(mensaje,"More than one file in loading process.\n\nSelect the desired file and press Cancel again."); 
         er->create(mensaje);
	  }
}

carga::carga()
{
	  register int t;

      for (t=0;t<3;t++) boton[t] = new CButton;
	  tip = new CToolTipCtrl;
	  titulo = new CBitmapButton;
	  for (t=0;t<4;t++) tool[t] = new CButton;
	  
	  indicador=0;
}

carga::~carga()
{
	  register int t;

      for (t=0;t<4;t++) delete tool[t];
      for (t=0;t<3;t++) delete boton[t];
	  delete tip;
	  delete titulo;
}

